--- a/ext/pdo_mysql/mysql_statement.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/pdo_mysql/mysql_statement.c	2025-11-18 21:43:27.179797646 +0000
@@ -715,7 +715,7 @@
 
 static char *type_to_name_native(int type) /* {{{ */
 {
-#define PDO_MYSQL_NATIVE_TYPE_NAME(x)	case FIELD_TYPE_##x: return #x;
+#define PDO_MYSQL_NATIVE_TYPE_NAME(x)	case MYSQL_TYPE_##x: return #x;
 
 	switch (type) {
 		PDO_MYSQL_NATIVE_TYPE_NAME(STRING)
@@ -749,6 +749,13 @@
 #ifdef FIELD_TYPE_NEWDATE
 		PDO_MYSQL_NATIVE_TYPE_NAME(NEWDATE)
 #endif
+		/* The following 2 don't have BC FIELD_TYPE_* aliases. */
+#if (MYSQL_VERSION_ID >= 90000 && !defined(MARIADB_BASE_VERSION)) || defined(PDO_USE_MYSQLND)
+		PDO_MYSQL_NATIVE_TYPE_NAME(VECTOR)
+#endif
+#if MYSQL_VERSION_ID >= 50708 || defined(PDO_USE_MYSQLND)
+		PDO_MYSQL_NATIVE_TYPE_NAME(JSON)
+#endif
 		PDO_MYSQL_NATIVE_TYPE_NAME(TIME)
 		PDO_MYSQL_NATIVE_TYPE_NAME(DATETIME)
 		PDO_MYSQL_NATIVE_TYPE_NAME(TINY_BLOB)
diff '--color=auto' -Naur a/ext/pdo_mysql/tests/gh20122.phpt b/ext/pdo_mysql/tests/gh20122.phpt
--- a/ext/pdo_mysql/tests/gh20122.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/pdo_mysql/tests/gh20122.phpt	2025-11-18 21:43:27.180227027 +0000
@@ -0,0 +1,32 @@
+--TEST--
+GH-20122 (getColumnMeta() for JSON-column in MySQL)
+--EXTENSIONS--
+pdo
+pdo_mysql
+--SKIPIF--
+<?php
+require_once __DIR__ . '/inc/mysql_pdo_test.inc';
+MySQLPDOTest::skip();
+?>
+--FILE--
+<?php
+require_once __DIR__ . '/inc/mysql_pdo_test.inc';
+$db = MySQLPDOTest::factory();
+
+$db->exec('CREATE TABLE test_gh20122 (bar JSON)');
+$db->exec('INSERT INTO test_gh20122 VALUES("[]")');
+
+$stmt = $db->query('SELECT * from test_gh20122');
+$meta = $stmt->getColumnMeta(0);
+
+// Note: JSON is an alias for LONGTEXT on MariaDB!
+echo $meta['native_type'], "\n";
+?>
+--CLEAN--
+<?php
+require_once __DIR__ . '/inc/mysql_pdo_test.inc';
+$pdo = MySQLPDOTest::factory();
+$pdo->query('DROP TABLE IF EXISTS test_gh20122');
+?>
+--EXPECTF--
+%r(JSON|LONGTEXT)%r
diff '--color=auto' -Naur a/ext/pgsql/pgsql.c b/ext/pgsql/pgsql.c
--- a/ext/pgsql/pgsql.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/pgsql/pgsql.c	2025-11-18 21:43:27.180566087 +0000
@@ -1210,15 +1210,13 @@
 
 static void _php_pgsql_free_params(char **params, int num_params)
 {
-	if (num_params > 0) {
-		int i;
-		for (i = 0; i < num_params; i++) {
-			if (params[i]) {
-				efree(params[i]);
-			}
+	int i;
+	for (i = 0; i < num_params; i++) {
+		if (params[i]) {
+			efree(params[i]);
 		}
-		efree(params);
 	}
+	efree(params);
 }
 
 /* Execute a query */
@@ -2066,7 +2064,10 @@
 		zval dataset;
 
 		ZVAL_COPY_VALUE(&dataset, return_value);
-		object_init_ex(return_value, ce);
+		zend_result obj_initialized = object_init_ex(return_value, ce);
+		if (UNEXPECTED(obj_initialized == FAILURE)) {
+			RETURN_THROWS();
+		}
 		if (!ce->default_properties_count && !ce->__set) {
 			Z_OBJ_P(return_value)->properties = Z_ARR(dataset);
 		} else {
diff '--color=auto' -Naur a/ext/pgsql/tests/inc/config.inc b/ext/pgsql/tests/inc/config.inc
--- a/ext/pgsql/tests/inc/config.inc	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/pgsql/tests/inc/config.inc	2025-11-18 21:43:27.182196184 +0000
@@ -6,4 +6,3 @@
 
 // "test" database must exist. i.e. "createdb test" before testing
 $conn_str = getenv('PGSQL_TEST_CONNSTR') ?: "host=localhost dbname=test port=5432 user=postgres password=postgres";    // connection string
-?>
diff '--color=auto' -Naur a/ext/pgsql/tests/inc/lcmess.inc b/ext/pgsql/tests/inc/lcmess.inc
--- a/ext/pgsql/tests/inc/lcmess.inc	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/pgsql/tests/inc/lcmess.inc	2025-11-18 21:43:27.182363861 +0000
@@ -17,5 +17,3 @@
 
     return true;
 }
-
-?>
diff '--color=auto' -Naur a/ext/pgsql/tests/inc/skipif.inc b/ext/pgsql/tests/inc/skipif.inc
--- a/ext/pgsql/tests/inc/skipif.inc	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/pgsql/tests/inc/skipif.inc	2025-11-18 21:43:27.182467637 +0000
@@ -1,4 +1,3 @@
-
 <?php
 // This script prints "skip" unless:
 // * the pgsql extension is built-in or loadable, AND
@@ -47,5 +46,3 @@
         die("skip libpq or backend >= 9.0\n");
     }
 }
-
-?>
diff '--color=auto' -Naur a/ext/pgsql/tests/pg_fetch_object_with_abstract_class.phpt b/ext/pgsql/tests/pg_fetch_object_with_abstract_class.phpt
--- a/ext/pgsql/tests/pg_fetch_object_with_abstract_class.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/pgsql/tests/pg_fetch_object_with_abstract_class.phpt	2025-11-18 21:43:27.182600458 +0000
@@ -0,0 +1,59 @@
+--TEST--
+pg_fetch_object() with abstract class name
+--EXTENSIONS--
+pgsql
+--SKIPIF--
+<?php
+include("inc/skipif.inc");
+?>
+--FILE--
+<?php
+
+interface I {}
+
+abstract class C {}
+
+enum E {
+	case A;
+}
+
+include "inc/config.inc";
+$table_name = "pg_fetch_object_abstract_class";
+$db = pg_connect($conn_str);
+pg_query($db, "CREATE TABLE {$table_name} (a integer, b text)");
+pg_query($db, "INSERT INTO {$table_name} VALUES(0, 'ABC')");
+
+$sql = "SELECT * FROM $table_name WHERE a = 0";
+
+try {
+	$result = pg_query($db, $sql);
+	var_dump(pg_fetch_object($result, NULL, 'I'));
+} catch(Throwable $e) {
+	echo $e::class, ': ', $e->getMessage(), PHP_EOL;
+}
+
+try {
+	$result = pg_query($db, $sql);
+	var_dump(pg_fetch_object($result, NULL, 'C'));
+} catch(Throwable $e) {
+	echo $e::class, ': ', $e->getMessage(), PHP_EOL;
+}
+
+try {
+	$result = pg_query($db, $sql);
+	var_dump(pg_fetch_object($result, NULL, 'E'));
+} catch(Throwable $e) {
+	echo $e::class, ': ', $e->getMessage(), PHP_EOL;
+}
+
+?>
+--CLEAN--
+<?php
+include('inc/config.inc');
+$db = @pg_connect($conn_str);
+@pg_query($db, "DROP TABLE IF EXISTS pg_fetch_object_abstract_class cascade");
+?>
+--EXPECT--
+Error: Cannot instantiate interface I
+Error: Cannot instantiate abstract class C
+Error: Cannot instantiate enum E
diff '--color=auto' -Naur a/ext/phar/phar.c b/ext/phar/phar.c
--- a/ext/phar/phar.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/phar.c	2025-11-18 21:43:27.182745251 +0000
@@ -1592,7 +1592,7 @@
 }
 /* }}}*/
 
-static inline char *phar_strnstr(const char *buf, int buf_len, const char *search, int search_len) /* {{{ */
+static inline char *phar_strnstr(const char *buf, size_t buf_len, const char *search, size_t search_len) /* {{{ */
 {
 	const char *c;
 	ptrdiff_t so_far = 0;
@@ -1674,6 +1674,12 @@
 				if (!PHAR_G(has_zlib)) {
 					MAPPHAR_ALLOC_FAIL("unable to decompress gzipped phar archive \"%s\" to temporary file, enable zlib extension in php.ini")
 				}
+
+				/* entire file is gzip-compressed, uncompress to temporary file */
+				if (!(temp = php_stream_fopen_tmpfile())) {
+					MAPPHAR_ALLOC_FAIL("unable to create temporary file for decompression of gzipped phar archive \"%s\"")
+				}
+
 				array_init(&filterparams);
 /* this is defined in zlib's zconf.h */
 #ifndef MAX_WBITS
@@ -1681,11 +1687,6 @@
 #endif
 				add_assoc_long_ex(&filterparams, "window", sizeof("window") - 1, MAX_WBITS + 32);
 
-				/* entire file is gzip-compressed, uncompress to temporary file */
-				if (!(temp = php_stream_fopen_tmpfile())) {
-					MAPPHAR_ALLOC_FAIL("unable to create temporary file for decompression of gzipped phar archive \"%s\"")
-				}
-
 				php_stream_rewind(fp);
 				filter = php_stream_filter_create("zlib.inflate", &filterparams, php_stream_is_persistent(fp));
 
diff '--color=auto' -Naur a/ext/phar/phar_object.c b/ext/phar/phar_object.c
--- a/ext/phar/phar_object.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/phar_object.c	2025-11-18 21:43:27.184566139 +0000
@@ -697,12 +697,15 @@
 		rewrite_fci.retval = &retval;
 
 		if (FAILURE == zend_call_function(&rewrite_fci, &rewrite_fcc)) {
+			zval_ptr_dtor_str(&params);
 			if (!EG(exception)) {
 				zend_throw_exception_ex(phar_ce_PharException, 0, "phar error: failed to call rewrite callback");
 			}
 			goto cleanup_fail;
 		}
 
+		zval_ptr_dtor_str(&params);
+
 		if (Z_TYPE_P(rewrite_fci.retval) == IS_UNDEF || Z_TYPE(retval) == IS_UNDEF) {
 			zend_throw_exception_ex(phar_ce_PharException, 0, "phar error: rewrite callback must return a string or false");
 			goto cleanup_fail;
@@ -728,7 +731,6 @@
 				zend_throw_exception_ex(phar_ce_PharException, 0, "phar error: rewrite callback must return a string or false");
 
 cleanup_fail:
-				zval_ptr_dtor(&params);
 				if (free_pathinfo) {
 					efree(path_info);
 				}
@@ -1790,6 +1792,10 @@
 	pass.ret = return_value;
 	pass.fp = php_stream_fopen_tmpfile();
 	if (pass.fp == NULL) {
+		zval_ptr_dtor(&iteriter);
+		if (apply_reg) {
+			zval_ptr_dtor(&regexiter);
+		}
 		zend_throw_exception_ex(phar_ce_PharException, 0, "phar \"%s\" unable to create temporary file", phar_obj->archive->fname);
 		RETURN_THROWS();
 	}
@@ -2776,6 +2782,7 @@
 	phar_flush(phar_obj->archive, &error);
 
 	if (error) {
+		pefree(phar_obj->archive->alias, phar_obj->archive->is_persistent);
 		phar_obj->archive->alias = oldalias;
 		phar_obj->archive->alias_len = oldalias_len;
 		phar_obj->archive->is_temporary_alias = old_temp;
@@ -4513,6 +4520,9 @@
 	entry_obj->entry = entry_info;
 	if (!entry_info->is_persistent && !entry_info->is_temp_dir) {
 		++entry_info->fp_refcount;
+		/* The phar data must exist to keep the alias locked. */
+		ZEND_ASSERT(!phar_data->is_persistent);
+		++phar_data->refcount;
 	}
 
 	ZVAL_STRINGL(&arg1, fname, fname_len);
@@ -4543,23 +4553,26 @@
 		RETURN_THROWS();
 	}
 
-	if (!entry_obj->entry) {
+	phar_entry_info *entry = entry_obj->entry;
+	if (!entry) {
 		return;
 	}
 
-	if (entry_obj->entry->is_temp_dir) {
-		if (entry_obj->entry->filename) {
-			efree(entry_obj->entry->filename);
-			entry_obj->entry->filename = NULL;
+	if (entry->is_temp_dir) {
+		if (entry->filename) {
+			efree(entry->filename);
+			entry->filename = NULL;
 		}
 
-		efree(entry_obj->entry);
-	} else if (!entry_obj->entry->is_persistent) {
-		--entry_obj->entry->fp_refcount;
-		/* It is necessarily still in the manifest, which will ultimately free this. */
+		efree(entry);
+		entry_obj->entry = NULL;
+	} else if (!entry->is_persistent) {
+		--entry->fp_refcount;
+		/* The entry itself still lives in the manifest,
+		 * which will either be freed here if the file info was the last reference; or freed later. */
+		entry_obj->entry = NULL;
+		phar_archive_delref(entry->phar);
 	}
-
-	entry_obj->entry = NULL;
 }
 /* }}} */
 
diff '--color=auto' -Naur a/ext/phar/stream.c b/ext/phar/stream.c
--- a/ext/phar/stream.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/stream.c	2025-11-18 21:43:27.185806230 +0000
@@ -670,7 +670,7 @@
 {
 	php_url *resource;
 	char *internal_file, *error;
-	int internal_file_len;
+	size_t internal_file_len;
 	phar_entry_data *idata;
 	phar_archive_data *pphar;
 
diff '--color=auto' -Naur a/ext/phar/tests/gh20302.phpt b/ext/phar/tests/gh20302.phpt
--- a/ext/phar/tests/gh20302.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/phar/tests/gh20302.phpt	2025-11-18 21:43:27.186390082 +0000
@@ -0,0 +1,36 @@
+--TEST--
+GH-20302 (Freeing a phar alias may invalidate PharFileInfo objects)
+--EXTENSIONS--
+phar
+--INI--
+phar.require_hash=0
+--FILE--
+<?php
+$fname = __DIR__.'/gh20302.phar';
+$pname = 'phar://' . $fname;
+$file = "<?php
+__HALT_COMPILER(); ?>";
+$files = array();
+$files['here'] = 'a';
+include __DIR__.'/files/phar_test.inc';
+$b = new PharFileInfo($pname . '/here');
+
+// Create new phar with same alias and open it
+@mkdir(__DIR__.'/gh20302');
+$fname = __DIR__.'/gh20302/gh20302.phar';
+$pname = 'phar://' . $fname;
+include __DIR__.'/files/phar_test.inc';
+try {
+    new Phar($fname);
+} catch (UnexpectedValueException $e) {
+    echo $e->getMessage(), "\n";
+}
+?>
+--CLEAN--
+<?php
+@unlink(__DIR__.'/gh20302/gh20302.phar');
+@unlink(__DIR__.'/gh20302.phar');
+@rmdir(__DIR__.'/gh20302');
+?>
+--EXPECTF--
+Cannot open archive "%sgh20302.phar", alias is already in use by existing archive
diff '--color=auto' -Naur a/ext/phar/tests/openssl_sign_invalid_polyfill_return_value.phpt b/ext/phar/tests/openssl_sign_invalid_polyfill_return_value.phpt
--- a/ext/phar/tests/openssl_sign_invalid_polyfill_return_value.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/phar/tests/openssl_sign_invalid_polyfill_return_value.phpt	2025-11-18 21:43:27.186719755 +0000
@@ -0,0 +1,34 @@
+--TEST--
+openssl_sign() polyfill with wrong return value
+--EXTENSIONS--
+phar
+--SKIPIF--
+<?php
+if (getenv('SKIP_SLOW_TESTS')) die('skip');
+if (function_exists('openssl_sign')) die('skip requires openssl disabled for mocking purposes');
+?>
+--INI--
+phar.require_hash=0
+--FILE--
+<?php
+$fname = __DIR__ . '/' . basename(__FILE__, '.php') . '.tar';
+
+function openssl_sign() {
+    return str_repeat('foobar', random_int(1, 1));
+}
+
+$phar = new PharData($fname);
+$phar->setSignatureAlgorithm(Phar::OPENSSL, "randomcrap");
+try {
+    $phar->addEmptyDir('blah');
+} catch (PharException $e) {
+    echo $e->getMessage();
+}
+
+?>
+--CLEAN--
+<?php
+@unlink(__DIR__ . '/' . basename(__FILE__, '.clean.php') . '.tar');
+?>
+--EXPECTF--
+phar error: unable to write signature to tar-based phar: unable to write phar "%s" with requested openssl signature
diff '--color=auto' -Naur a/ext/phar/tests/tar/bug70417.phpt b/ext/phar/tests/tar/bug70417.phpt
--- a/ext/phar/tests/tar/bug70417.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/tests/tar/bug70417.phpt	2025-11-18 21:43:27.186798082 +0000
@@ -3,32 +3,17 @@
 --EXTENSIONS--
 phar
 zlib
---SKIPIF--
-<?php
-
-exec('lsof -p ' . getmypid(), $out, $status);
-if ($status !== 0) {
-    die("skip lsof(8) not available");
-}
-if (!str_starts_with($out[0], 'COMMAND')) {
-    die("skip Might be a different lsof");
-}
-?>
 --FILE--
 <?php
-function countOpenFiles() {
-    exec('lsof -p ' . escapeshellarg(getmypid()) . ' 2> /dev/null', $out);  // Note: valgrind can produce false positives for /usr/bin/lsof
-    return count($out);
-}
 $filename = __DIR__ . '/bug70417.tar';
 @unlink("$filename.gz");
-$openFiles1 = countOpenFiles();
+$resBefore = count(get_resources());
 $arch = new PharData($filename);
 $arch->addFromString('foo', 'bar');
 $arch->compress(Phar::GZ);
 unset($arch);
-$openFiles2 = countOpenFiles();
-var_dump($openFiles1 === $openFiles2);
+$resAfter = count(get_resources());
+var_dump($resBefore === $resAfter);
 ?>
 --CLEAN--
 <?php
diff '--color=auto' -Naur a/ext/phar/util.c b/ext/phar/util.c
--- a/ext/phar/util.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/util.c	2025-11-18 21:43:27.187069705 +0000
@@ -1520,7 +1520,6 @@
 	zval_ptr_dtor_str(&zp[2]);
 
 	switch (Z_TYPE(retval)) {
-		default:
 		case IS_LONG:
 			zval_ptr_dtor(&zp[1]);
 			if (1 == Z_LVAL(retval)) {
@@ -1532,6 +1531,9 @@
 			*signature_len = Z_STRLEN(zp[1]);
 			zval_ptr_dtor(&zp[1]);
 			return SUCCESS;
+		default:
+			zval_ptr_dtor(&retval);
+			ZEND_FALLTHROUGH;
 		case IS_FALSE:
 			zval_ptr_dtor(&zp[1]);
 			return FAILURE;
diff '--color=auto' -Naur a/ext/phar/zip.c b/ext/phar/zip.c
--- a/ext/phar/zip.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/phar/zip.c	2025-11-18 21:43:27.187806206 +0000
@@ -345,29 +345,8 @@
 	entry.is_zip = 1;
 	entry.fp_type = PHAR_FP;
 	entry.is_persistent = mydata->is_persistent;
-#define PHAR_ZIP_FAIL_FREE(errmsg, save) \
-			zend_hash_destroy(&mydata->manifest); \
-			HT_INVALIDATE(&mydata->manifest); \
-			zend_hash_destroy(&mydata->mounted_dirs); \
-			HT_INVALIDATE(&mydata->mounted_dirs); \
-			zend_hash_destroy(&mydata->virtual_dirs); \
-			HT_INVALIDATE(&mydata->virtual_dirs); \
-			php_stream_close(fp); \
-			phar_metadata_tracker_free(&mydata->metadata_tracker, mydata->is_persistent); \
-			if (mydata->signature) { \
-				efree(mydata->signature); \
-			} \
-			if (error) { \
-				spprintf(error, 4096, "phar error: %s in zip-based phar \"%s\"", errmsg, mydata->fname); \
-			} \
-			pefree(mydata->fname, mydata->is_persistent); \
-			if (mydata->alias) { \
-				pefree(mydata->alias, mydata->is_persistent); \
-			} \
-			pefree(mydata, mydata->is_persistent); \
-			efree(save); \
-			return FAILURE;
 #define PHAR_ZIP_FAIL(errmsg) \
+			efree(actual_alias); \
 			zend_hash_destroy(&mydata->manifest); \
 			HT_INVALIDATE(&mydata->manifest); \
 			zend_hash_destroy(&mydata->mounted_dirs); \
@@ -521,14 +500,13 @@
 			mydata->sig_flags = PHAR_GET_32(sig);
 			if (FAILURE == phar_verify_signature(sigfile, php_stream_tell(sigfile), mydata->sig_flags, sig + 8, entry.uncompressed_filesize - 8, fname, &mydata->signature, &sig_len, error)) {
 				efree(sig);
+				php_stream_close(sigfile);
 				if (error) {
-					char *save;
-					php_stream_close(sigfile);
-					spprintf(&save, 4096, "signature cannot be verified: %s", *error);
+					char errmsg[128];
+					snprintf(errmsg, sizeof(errmsg), "signature cannot be verified: %s", *error);
 					efree(*error);
-					PHAR_ZIP_FAIL_FREE(save, save);
+					PHAR_ZIP_FAIL(errmsg);
 				} else {
-					php_stream_close(sigfile);
 					PHAR_ZIP_FAIL("signature cannot be verified");
 				}
 			}
@@ -673,7 +651,7 @@
 					}
 				}
 
-				if (!entry.uncompressed_filesize || !actual_alias) {
+				if (!entry.uncompressed_filesize) {
 					php_stream_filter_remove(filter, 1);
 					pefree(entry.filename, entry.is_persistent);
 					PHAR_ZIP_FAIL("unable to read in alias, truncated");
@@ -706,7 +684,7 @@
 					}
 				}
 
-				if (!entry.uncompressed_filesize || !actual_alias) {
+				if (!entry.uncompressed_filesize) {
 					php_stream_filter_remove(filter, 1);
 					pefree(entry.filename, entry.is_persistent);
 					PHAR_ZIP_FAIL("unable to read in alias, truncated");
@@ -729,7 +707,7 @@
 					}
 				}
 
-				if (!entry.uncompressed_filesize || !actual_alias) {
+				if (!entry.uncompressed_filesize) {
 					pefree(entry.filename, entry.is_persistent);
 					PHAR_ZIP_FAIL("unable to read in alias, truncated");
 				}
@@ -1298,6 +1276,7 @@
 			return;
 		}
 		if (phar->alias_len != php_stream_write(entry.fp, phar->alias, phar->alias_len)) {
+			php_stream_close(entry.fp);
 			if (error) {
 				spprintf(error, 0, "unable to set alias in zip-based phar \"%s\"", phar->fname);
 			}
@@ -1422,6 +1401,7 @@
 	pass.centralfp = php_stream_fopen_tmpfile();
 
 	if (!pass.centralfp) {
+		php_stream_close(pass.filefp);
 		goto fperror;
 	}
 
diff '--color=auto' -Naur a/ext/random/engine_mt19937.c b/ext/random/engine_mt19937.c
--- a/ext/random/randomizer.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/random/randomizer.c	2025-11-18 21:43:27.188832533 +0000
@@ -516,8 +516,7 @@
 	ZEND_PARSE_PARAMETERS_NONE();
 
 	array_init(return_value);
-	ZVAL_ARR(&t, zend_std_get_properties(&randomizer->std));
-	Z_TRY_ADDREF(t);
+	ZVAL_ARR(&t, zend_array_dup(zend_std_get_properties(&randomizer->std)));
 	zend_hash_next_index_insert(Z_ARRVAL_P(return_value), &t);
 }
 /* }}} */
diff '--color=auto' -Naur a/ext/random/tests/03_randomizer/methods/__serialize_indirects.phpt b/ext/random/tests/03_randomizer/methods/__serialize_indirects.phpt
--- a/ext/random/tests/03_randomizer/methods/__serialize_indirects.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/random/tests/03_randomizer/methods/__serialize_indirects.phpt	2025-11-18 21:43:27.189151626 +0000
@@ -0,0 +1,18 @@
+--TEST--
+Random: Engine: __serialize() must not expose INDIRECTs
+--FILE--
+<?php
+
+$randomizer = new Random\Randomizer(null);
+var_dump($randomizer->__serialize());
+
+?>
+--EXPECT--
+array(1) {
+  [0]=>
+  array(1) {
+    ["engine"]=>
+    object(Random\Engine\Secure)#2 (0) {
+    }
+  }
+}
diff '--color=auto' -Naur a/ext/reflection/php_reflection.c b/ext/reflection/php_reflection.c
--- a/ext/reflection/php_reflection.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/reflection/php_reflection.c	2025-11-18 21:43:27.190566216 +0000
@@ -5696,7 +5696,8 @@
 		RETURN_FALSE;
 	}
 
-	RETURN_BOOL(ce->get_iterator || instanceof_function(ce, zend_ce_traversable));
+	RETURN_BOOL((ce->get_iterator && ce->get_iterator != zend_hooked_object_get_iterator)
+				|| instanceof_function(ce, zend_ce_traversable));
 }
 /* }}} */
 
diff '--color=auto' -Naur a/ext/reflection/tests/ReflectionClass_isIterable_gh20217.phpt b/ext/reflection/tests/ReflectionClass_isIterable_gh20217.phpt
--- a/ext/reflection/tests/ReflectionClass_isIterable_gh20217.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/reflection/tests/ReflectionClass_isIterable_gh20217.phpt	2025-11-18 21:43:27.191313647 +0000
@@ -0,0 +1,38 @@
+--TEST--
+GH-20217 (ReflectionClass::isIterable() should return false for classes with property hooks)
+--FILE--
+<?php
+
+class ClassWithPropertyHooks
+{
+    public string $name {
+        get => 'virtual';
+    }
+}
+
+class IterableClassWithPropertyHooks implements IteratorAggregate
+{
+    public string $name {
+        get => 'virtual';
+    }
+
+    public function getIterator(): Traversable
+    {
+        return new ArrayIterator([]);
+    }
+}
+
+$classes = [
+    'ClassWithPropertyHooks' => false,
+    'IterableClassWithPropertyHooks' => true,
+];
+
+foreach ($classes as $className => $expected) {
+    $status = (new ReflectionClass($className)->isIterable() === $expected) ? 'PASS' : 'FAIL';
+    echo "$className: $status\n";
+}
+
+?>
+--EXPECT--
+ClassWithPropertyHooks: PASS
+IterableClassWithPropertyHooks: PASS
diff '--color=auto' -Naur a/ext/simplexml/simplexml.c b/ext/simplexml/simplexml.c
--- a/ext/simplexml/simplexml.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/simplexml/simplexml.c	2025-11-18 21:43:27.191566229 +0000
@@ -1202,12 +1202,12 @@
 }
 /* }}} */
 
-static HashTable * sxe_get_debug_info(zend_object *object, int *is_temp) /* {{{ */
+/* This custom handler exists because the var_dump adds a pseudo "@attributes" key. */
+PHP_METHOD(SimpleXMLElement, __debugInfo)
 {
-	*is_temp = 1;
-	return sxe_get_prop_hash(object, 1);
+	ZEND_PARSE_PARAMETERS_NONE();
+	RETURN_ARR(sxe_get_prop_hash(Z_OBJ_P(ZEND_THIS), 1));
 }
-/* }}} */
 
 static int sxe_objects_compare(zval *object1, zval *object2) /* {{{ */
 {
@@ -2682,7 +2682,6 @@
 	sxe_object_handlers.compare = sxe_objects_compare;
 	sxe_object_handlers.cast_object = sxe_object_cast;
 	sxe_object_handlers.count_elements = sxe_count_elements;
-	sxe_object_handlers.get_debug_info = sxe_get_debug_info;
 	sxe_object_handlers.get_closure = NULL;
 	sxe_object_handlers.get_gc = sxe_get_gc;
 
diff '--color=auto' -Naur a/ext/simplexml/simplexml.stub.php b/ext/simplexml/simplexml.stub.php
--- a/ext/simplexml/simplexml.stub.php	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/simplexml/simplexml.stub.php	2025-11-18 21:43:27.192320458 +0000
@@ -51,6 +51,8 @@
 
     public function __toString(): string {}
 
+    public function __debugInfo(): ?array {}
+
     /** @tentative-return-type */
     public function count(): int {}
 
diff '--color=auto' -Naur a/ext/simplexml/simplexml_arginfo.h b/ext/simplexml/simplexml_arginfo.h
--- a/ext/simplexml/simplexml_arginfo.h	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/simplexml/simplexml_arginfo.h	2025-11-18 21:43:27.192466664 +0000
@@ -1,5 +1,5 @@
 /* This is a generated file, edit the .stub.php file instead.
- * Stub hash: 36eac2dee86bcc386c24e2cc14caa7bd3d709e82 */
+ * Stub hash: cee51320f0f09f14962fb72125ef8ff6073a642a */
 
 ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(arginfo_simplexml_load_file, 0, 1, SimpleXMLElement, MAY_BE_FALSE)
 	ZEND_ARG_TYPE_INFO(0, filename, IS_STRING, 0)
@@ -79,6 +79,9 @@
 ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(arginfo_class_SimpleXMLElement___toString, 0, 0, IS_STRING, 0)
 ZEND_END_ARG_INFO()
 
+ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(arginfo_class_SimpleXMLElement___debugInfo, 0, 0, IS_ARRAY, 1)
+ZEND_END_ARG_INFO()
+
 ZEND_BEGIN_ARG_WITH_TENTATIVE_RETURN_TYPE_INFO_EX(arginfo_class_SimpleXMLElement_count, 0, 0, IS_LONG, 0)
 ZEND_END_ARG_INFO()
 
@@ -115,6 +118,7 @@
 ZEND_METHOD(SimpleXMLElement, addAttribute);
 ZEND_METHOD(SimpleXMLElement, getName);
 ZEND_METHOD(SimpleXMLElement, __toString);
+ZEND_METHOD(SimpleXMLElement, __debugInfo);
 ZEND_METHOD(SimpleXMLElement, count);
 ZEND_METHOD(SimpleXMLElement, rewind);
 ZEND_METHOD(SimpleXMLElement, valid);
@@ -145,6 +149,7 @@
 	ZEND_ME(SimpleXMLElement, addAttribute, arginfo_class_SimpleXMLElement_addAttribute, ZEND_ACC_PUBLIC)
 	ZEND_ME(SimpleXMLElement, getName, arginfo_class_SimpleXMLElement_getName, ZEND_ACC_PUBLIC)
 	ZEND_ME(SimpleXMLElement, __toString, arginfo_class_SimpleXMLElement___toString, ZEND_ACC_PUBLIC)
+	ZEND_ME(SimpleXMLElement, __debugInfo, arginfo_class_SimpleXMLElement___debugInfo, ZEND_ACC_PUBLIC)
 	ZEND_ME(SimpleXMLElement, count, arginfo_class_SimpleXMLElement_count, ZEND_ACC_PUBLIC)
 	ZEND_ME(SimpleXMLElement, rewind, arginfo_class_SimpleXMLElement_rewind, ZEND_ACC_PUBLIC)
 	ZEND_ME(SimpleXMLElement, valid, arginfo_class_SimpleXMLElement_valid, ZEND_ACC_PUBLIC)
diff '--color=auto' -Naur a/ext/simplexml/tests/gh16317.phpt b/ext/simplexml/tests/gh16317.phpt
--- a/ext/simplexml/tests/gh16317.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/simplexml/tests/gh16317.phpt	2025-11-18 21:43:27.192750350 +0000
@@ -0,0 +1,22 @@
+--TEST--
+GH-16317 (SimpleXML does not allow __debugInfo() overrides to work)
+--FILE--
+<?php
+
+class MySXE extends SimpleXMLElement {
+    public function __debugInfo(): array {
+        echo "invoked\n";
+        return ['x' => 1];
+    }
+}
+
+$sxe = simplexml_load_string('<root><a/></root>', MySXE::class);
+var_dump($sxe);
+
+?>
+--EXPECT--
+invoked
+object(MySXE)#1 (1) {
+  ["x"]=>
+  int(1)
+}
diff '--color=auto' -Naur a/ext/standard/tests/serialize/shm_corruption_coercion_unserialize_options.phpt b/ext/standard/tests/serialize/shm_corruption_coercion_unserialize_options.phpt
--- a/ext/standard/tests/serialize/shm_corruption_coercion_unserialize_options.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/serialize/shm_corruption_coercion_unserialize_options.phpt	2025-11-18 21:43:27.192895394 +0000
@@ -0,0 +1,14 @@
+--TEST--
+Shm corruption with coercion in options of unserialize()
+--FILE--
+<?php
+class MyStringable {
+    public function __toString(): string {
+        return "0";
+    }
+}
+
+unserialize("{}", ["allowed_classes" => [new MyStringable]]);
+?>
+--EXPECTF--
+Warning: unserialize(): Error at offset 0 of 2 bytes in %s on line %d
diff '--color=auto' -Naur a/ext/standard/tests/streams/bug60602.phpt b/ext/standard/tests/streams/bug60602.phpt
--- a/ext/standard/tests/streams/bug60602.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/standard/tests/streams/bug60602.phpt	2025-11-18 21:43:27.193067128 +0000
@@ -9,7 +9,7 @@
     2 => array('pipe', 'w'), // strerr
 );
 
-$environment = array('test' => array(1, 2, 3));
+$environment = array('test' => array(1, 2, 3), 'PATH' => getenv('PATH'));
 
 $cmd = (substr(PHP_OS, 0, 3) == 'WIN') ? 'dir' : 'ls';
 $p = proc_open($cmd, $descs, $pipes, '.', $environment);
diff '--color=auto' -Naur a/ext/standard/var.c b/ext/standard/var.c
--- a/ext/standard/var.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/standard/var.c	2025-11-18 21:43:27.193277315 +0000
@@ -1414,19 +1414,20 @@
 						function_name, zend_zval_value_name(entry));
 					goto cleanup;
 				}
-				zend_string *name = zval_try_get_string(entry);
+				zend_string *tmp_str;
+				zend_string *name = zval_try_get_tmp_string(entry, &tmp_str);
 				if (UNEXPECTED(name == NULL)) {
 					goto cleanup;
 				}
 				if (UNEXPECTED(!zend_is_valid_class_name(name))) {
 					zend_value_error("%s(): Option \"allowed_classes\" must be an array of class names, \"%s\" given", function_name, ZSTR_VAL(name));
-					zend_string_release_ex(name, false);
+					zend_tmp_string_release(tmp_str);
 					goto cleanup;
 				}
 				zend_string *lcname = zend_string_tolower(name);
 				zend_hash_add_empty_element(class_hash, lcname);
-		        zend_string_release_ex(name, false);
 		        zend_string_release_ex(lcname, false);
+		        zend_tmp_string_release(tmp_str);
 			} ZEND_HASH_FOREACH_END();
 		}
 		php_var_unserialize_set_allowed_classes(var_hash, class_hash);
diff '--color=auto' -Naur a/ext/tidy/config.m4 b/ext/tidy/config.m4
--- a/ext/tidy/config.m4	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/tidy/config.m4	2025-11-18 21:43:27.193921631 +0000
@@ -57,19 +57,34 @@
     [],
     [-L$TIDY_LIBDIR])
 
-  dnl The tidyOptGetCategory function (added in libtidy 5.4.0) if only useable
-  dnl if TidyInternalCategory (added in libtidy 5.6.0) is also present.
-  PHP_CHECK_LIBRARY([$TIDY_LIB_NAME], [tidyInternalCategory],
-    [AC_DEFINE([HAVE_TIDYOPTGETCATEGORY], [1],
-      [Define to 1 if Tidy library has the 'tidyOptGetCategory' function.])],
-    [],
-    [-L$TIDY_LIBDIR])
-
   PHP_ADD_LIBRARY_WITH_PATH([$TIDY_LIB_NAME],
     [$TIDY_LIBDIR],
     [TIDY_SHARED_LIBADD])
   PHP_ADD_INCLUDE([$TIDY_INCDIR])
 
+  old_CPPFLAGS=$CPPFLAGS
+  CPPFLAGS=-I$TIDY_INCDIR
+
+  dnl The tidyOptGetCategory function (added in tidy-html5 5.4.0) is only
+  dnl useable if TidyInternalCategory (added in tidy-html5 5.6.0) is also
+  dnl present.
+  AC_CACHE_CHECK([for tidyOptGetCategory], [php_ac_cv_have_tidyoptgetcategory],
+  [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <tidy.h>],[
+     TidyDoc doc = tidyCreate();
+     TidyOption badopt = tidyGetOptionByName(doc, "<bad>");
+     Bool v = (tidyOptGetCategory(badopt) == TidyInternalCategory);
+     (void)v;
+     tidyRelease(doc);
+    ])],
+    [php_ac_cv_have_tidyoptgetcategory=yes],
+    [php_ac_cv_have_tidyoptgetcategory=no])
+  ])
+  AS_VAR_IF([php_ac_cv_have_tidyoptgetcategory], [yes],
+    [AC_DEFINE([HAVE_TIDYOPTGETCATEGORY], [1],
+      [Define to 1 if tidyOptGetCategory is available.])])
+
+  CPPFLAGS=$old_CPPFLAGS
+
   dnl Add -Wno-ignored-qualifiers as this is an issue upstream. Fixed in
   dnl tidy-html5 5.7.20: https://github.com/htacg/tidy-html5/issues/866
   PHP_NEW_EXTENSION([tidy],
diff '--color=auto' -Naur a/ext/tidy/tidy.c b/ext/tidy/tidy.c
--- a/ext/tidy/tidy.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/tidy/tidy.c	2025-11-18 21:43:27.194089258 +0000
@@ -447,7 +447,7 @@
 				efree(intern->ptdoc->errbuf);
 				tidyRelease(intern->ptdoc->doc);
 				efree(intern->ptdoc);
-				efree(intern);
+				/* TODO: convert to exception */
 				php_error_docref(NULL, E_ERROR, "Could not set Tidy error buffer");
 			}
 
diff '--color=auto' -Naur a/ext/xmlreader/php_xmlreader.c b/ext/xmlreader/php_xmlreader.c
--- a/ext/xmlreader/php_xmlreader.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/xmlreader/php_xmlreader.c	2025-11-18 21:43:27.194654254 +0000
@@ -502,12 +502,7 @@
 
 /* {{{ php_xmlreader_set_relaxng_schema */
 static void php_xmlreader_set_relaxng_schema(INTERNAL_FUNCTION_PARAMETERS, int type) {
-#ifdef LIBXML_SCHEMAS_ENABLED
-	zval *id;
 	size_t source_len = 0;
-	int retval = -1;
-	xmlreader_object *intern;
-	xmlRelaxNGPtr schema = NULL;
 	char *source;
 
 	if (zend_parse_parameters(ZEND_NUM_ARGS(), "p!", &source, &source_len) == FAILURE) {
@@ -518,11 +513,13 @@
 		zend_argument_must_not_be_empty_error(1);
 		RETURN_THROWS();
 	}
-
-	id = ZEND_THIS;
-
-	intern = Z_XMLREADER_P(id);
+	
+#ifdef LIBXML_SCHEMAS_ENABLED
+	xmlreader_object *intern = Z_XMLREADER_P(ZEND_THIS);
 	if (intern->ptr) {
+		int retval = -1;
+		xmlRelaxNGPtr schema = NULL;
+
 		if (source) {
 			schema =  _xmlreader_get_relaxNG(source, source_len, type, NULL, NULL);
 			if (schema) {
@@ -1064,11 +1061,7 @@
 /* {{{ Use W3C XSD schema to validate the document as it is processed. Activation is only possible before the first Read(). */
 PHP_METHOD(XMLReader, setSchema)
 {
-#ifdef LIBXML_SCHEMAS_ENABLED
-	zval *id;
 	size_t source_len = 0;
-	int retval = -1;
-	xmlreader_object *intern;
 	char *source;
 
 	if (zend_parse_parameters(ZEND_NUM_ARGS(), "p!", &source, &source_len) == FAILURE) {
@@ -1079,13 +1072,12 @@
 		zend_argument_must_not_be_empty_error(1);
 		RETURN_THROWS();
 	}
-
-	id = ZEND_THIS;
-
-	intern = Z_XMLREADER_P(id);
+	
+#ifdef LIBXML_SCHEMAS_ENABLED
+	xmlreader_object *intern = Z_XMLREADER_P(ZEND_THIS);
 	if (intern && intern->ptr) {
 		PHP_LIBXML_SANITIZE_GLOBALS(schema);
-		retval = xmlTextReaderSchemaValidate(intern->ptr, source);
+		int retval = xmlTextReaderSchemaValidate(intern->ptr, source);
 		PHP_LIBXML_RESTORE_GLOBALS(schema);
 
 		if (retval == 0) {
diff '--color=auto' -Naur a/ext/zip/php_zip.c b/ext/zip/php_zip.c
